// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from depth_obstacle_detect_ros_msgs:msg/ObstacleStampedArray.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "depth_obstacle_detect_ros_msgs/msg/obstacle_stamped_array.hpp"


#ifndef DEPTH_OBSTACLE_DETECT_ROS_MSGS__MSG__DETAIL__OBSTACLE_STAMPED_ARRAY__STRUCT_HPP_
#define DEPTH_OBSTACLE_DETECT_ROS_MSGS__MSG__DETAIL__OBSTACLE_STAMPED_ARRAY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray __attribute__((deprecated))
#else
# define DEPRECATED__depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray __declspec(deprecated)
#endif

namespace depth_obstacle_detect_ros_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ObstacleStampedArray_
{
  using Type = ObstacleStampedArray_<ContainerAllocator>;

  explicit ObstacleStampedArray_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit ObstacleStampedArray_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _obstacle_detected_type =
    std::vector<bool, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bool>>;
  _obstacle_detected_type obstacle_detected;
  using _obstacle_distance_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _obstacle_distance_type obstacle_distance;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__obstacle_detected(
    const std::vector<bool, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bool>> & _arg)
  {
    this->obstacle_detected = _arg;
    return *this;
  }
  Type & set__obstacle_distance(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->obstacle_distance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator> *;
  using ConstRawPtr =
    const depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray
    std::shared_ptr<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray
    std::shared_ptr<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ObstacleStampedArray_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->obstacle_detected != other.obstacle_detected) {
      return false;
    }
    if (this->obstacle_distance != other.obstacle_distance) {
      return false;
    }
    return true;
  }
  bool operator!=(const ObstacleStampedArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ObstacleStampedArray_

// alias to use template instance with default allocator
using ObstacleStampedArray =
  depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace depth_obstacle_detect_ros_msgs

#endif  // DEPTH_OBSTACLE_DETECT_ROS_MSGS__MSG__DETAIL__OBSTACLE_STAMPED_ARRAY__STRUCT_HPP_
