// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from depth_obstacle_detect_ros_msgs:msg/ObstacleStampedArray.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "depth_obstacle_detect_ros_msgs/msg/obstacle_stamped_array.hpp"


#ifndef DEPTH_OBSTACLE_DETECT_ROS_MSGS__MSG__DETAIL__OBSTACLE_STAMPED_ARRAY__TRAITS_HPP_
#define DEPTH_OBSTACLE_DETECT_ROS_MSGS__MSG__DETAIL__OBSTACLE_STAMPED_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "depth_obstacle_detect_ros_msgs/msg/detail/obstacle_stamped_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace depth_obstacle_detect_ros_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ObstacleStampedArray & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: obstacle_detected
  {
    if (msg.obstacle_detected.size() == 0) {
      out << "obstacle_detected: []";
    } else {
      out << "obstacle_detected: [";
      size_t pending_items = msg.obstacle_detected.size();
      for (auto item : msg.obstacle_detected) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: obstacle_distance
  {
    if (msg.obstacle_distance.size() == 0) {
      out << "obstacle_distance: []";
    } else {
      out << "obstacle_distance: [";
      size_t pending_items = msg.obstacle_distance.size();
      for (auto item : msg.obstacle_distance) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ObstacleStampedArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: obstacle_detected
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.obstacle_detected.size() == 0) {
      out << "obstacle_detected: []\n";
    } else {
      out << "obstacle_detected:\n";
      for (auto item : msg.obstacle_detected) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: obstacle_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.obstacle_distance.size() == 0) {
      out << "obstacle_distance: []\n";
    } else {
      out << "obstacle_distance:\n";
      for (auto item : msg.obstacle_distance) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ObstacleStampedArray & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace depth_obstacle_detect_ros_msgs

namespace rosidl_generator_traits
{

[[deprecated("use depth_obstacle_detect_ros_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  depth_obstacle_detect_ros_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use depth_obstacle_detect_ros_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray & msg)
{
  return depth_obstacle_detect_ros_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray>()
{
  return "depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray";
}

template<>
inline const char * name<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray>()
{
  return "depth_obstacle_detect_ros_msgs/msg/ObstacleStampedArray";
}

template<>
struct has_fixed_size<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<depth_obstacle_detect_ros_msgs::msg::ObstacleStampedArray>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DEPTH_OBSTACLE_DETECT_ROS_MSGS__MSG__DETAIL__OBSTACLE_STAMPED_ARRAY__TRAITS_HPP_
