// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from depth_obstacle_detect_ros_msgs:msg/ObstacleStampedArray.idl
// generated code does not contain a copyright notice
#include "depth_obstacle_detect_ros_msgs/msg/detail/obstacle_stamped_array__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `obstacle_detected`
// Member `obstacle_distance`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__init(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__fini(msg);
    return false;
  }
  // obstacle_detected
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->obstacle_detected, 0)) {
    depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__fini(msg);
    return false;
  }
  // obstacle_distance
  if (!rosidl_runtime_c__double__Sequence__init(&msg->obstacle_distance, 0)) {
    depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__fini(msg);
    return false;
  }
  return true;
}

void
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__fini(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // obstacle_detected
  rosidl_runtime_c__boolean__Sequence__fini(&msg->obstacle_detected);
  // obstacle_distance
  rosidl_runtime_c__double__Sequence__fini(&msg->obstacle_distance);
}

bool
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__are_equal(const depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * lhs, const depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // obstacle_detected
  if (!rosidl_runtime_c__boolean__Sequence__are_equal(
      &(lhs->obstacle_detected), &(rhs->obstacle_detected)))
  {
    return false;
  }
  // obstacle_distance
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->obstacle_distance), &(rhs->obstacle_distance)))
  {
    return false;
  }
  return true;
}

bool
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__copy(
  const depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * input,
  depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // obstacle_detected
  if (!rosidl_runtime_c__boolean__Sequence__copy(
      &(input->obstacle_detected), &(output->obstacle_detected)))
  {
    return false;
  }
  // obstacle_distance
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->obstacle_distance), &(output->obstacle_distance)))
  {
    return false;
  }
  return true;
}

depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray *
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * msg = (depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray *)allocator.allocate(sizeof(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray));
  bool success = depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__destroy(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence__init(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * data = NULL;

  if (size) {
    data = (depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray *)allocator.zero_allocate(size, sizeof(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence__fini(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence *
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence * array = (depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence *)allocator.allocate(sizeof(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence__destroy(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence__are_equal(const depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence * lhs, const depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence__copy(
  const depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence * input,
  depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray * data =
      (depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!depth_obstacle_detect_ros_msgs__msg__ObstacleStampedArray__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
